using Avalonia;
using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Markup.Xaml;
using Avalonia.Media.Imaging;
using Avalonia.Platform.Storage;
using demoModels;
using System;
using System.ComponentModel.Design;
using System.Linq;
using System.Threading.Tasks;

namespace demo;

public partial class ProductWindow : Window
{
    public string PathToImage = string.Empty;



    public ProductWindow()
    {
        using ProductsTradeContext context = new ProductsTradeContext();
        InitializeComponent();
        ProductId.IsVisible = false;
        ProductIdLabel.IsVisible = false;
        ProductIdLabel.IsVisible = false;
        EditButton.IsVisible = false;
        ProductManufacture.ItemsSource = context.Manufacturers.Select(it => it.Name).ToList();

    }
    private async Task<Bitmap?> SelectImageAndSaveImage()
    {
        var showDilaog = StorageProvider.OpenFilePickerAsync(
            new Avalonia.Platform.Storage.FilePickerOpenOptions()
            {
                Title = " ",
                FileTypeFilter = new[] { FilePickerFileTypes.ImageAll }
            });
       var storageFile =  await showDilaog;
        try
        {
            var bmp = new Bitmap(storageFile.First().TryGetLocalPath());
            string path = $" \\{Guid.NewGuid()}.jpg";
            bmp.Save(path);
            PathToImage = path;
            return bmp;
        }
        catch
        {
            return null;
        } 
    }
    public async void AddClick(object sender, RoutedEventArgs e)
    {
        using ProductsTradeContext context = new ProductsTradeContext();
        ProductPresenter presenter = new ProductPresenter();        
        if (!decimal.TryParse(ProductCost.Text, out decimal cost)) return;
        if (cost < 0) return;
        presenter.Cost = cost;
        if (string.IsNullOrEmpty(ProductName.Text)) return;
        presenter.Title = ProductName.Text;
        if (string.IsNullOrEmpty(ProductDesc.Text)) return;
        presenter.Description = ProductDesc.Text;
        var findManufacture = context.Manufacturers.First(it => it.Name == ProductManufacture.SelectedItem.ToString());
        if (findManufacture == null) return;
        presenter.Manufacturerid = findManufacture.Id;
        presenter.Isactive = IsActiveBox.IsPressed;
        if (String.IsNullOrEmpty(PathToImage)) return;
        presenter.Mainimagepath = PathToImage;
        Close(presenter);
    }
    public void EditClick(object sender, RoutedEventArgs e)
    {
    }
    public async void AddImageClick(object sender, RoutedEventArgs e)
    {
        ProductImage.Source = await SelectImageAndSaveImage();
    }
}